from Mods.ModMenu.KeybindManager import InputEvent
from Mods.ModMenu.Options import Boolean, Slider, Spinner
from Mods.ModUtils import SdkMod, Settings


class FpsToggle(SdkMod):
	__doc__ = 'Switch to and from 30 FPS with a hotkey'

	Name = 'FPS Toggle'
	Description = __doc__
	Author = 'Izalia Mae'
	Version = '1.0'


	def __init__(self):
		self.settings = Settings()
		self.current = None

		self.set_types('Utility')
		self.set_enable_state('settings')

		self.Keybinds.new(
			'Toggle FPS', 'F4',
			rebindable = True
		)


	def handle_game_input(self, bind, event):
		if event != InputEvent.Pressed:
			return

		if self.current == None:
			self.current = self.settings['FramerateLocking']
			self.settings['FramerateLocking'] = 1

		else:
			self.settings['FramerateLocking'] = self.current or 0
			self.current = None


mod = FpsToggle()
mod.register()
